<script setup lang="ts">
import * as monaco from 'monaco-editor'
import registerPlaceholderProvider from 'services/autocomplete/placeholders/provider'
import registerFilterProvider from 'services/autocomplete/TESL/provider'
import registerHoverProvider from 'services/hover/provider'
import languageConfig from 'services/langConfig'
import languageOptions from 'services/langOptions'
import { highlighterConfig } from 'services/highlighting'
import { useEditorStore } from 'store/editorStore'
import { useErrorStore } from 'store/errorStore'
import { themeColorsLight, tokenColorsLight } from 'services/theme'
import { errorRangeKey } from 'store/events'
import ValidatorWorker from 'services/diagnostic/validatorWorker?worker'

const editorStore = useEditorStore()
const errorStore = useErrorStore()
let editor: monaco.editor.IStandaloneCodeEditor
let validator: Worker
let validatorListener: monaco.IDisposable | undefined

// Language Handling
monaco.languages.setLanguageConfiguration('html', languageConfig)
monaco.languages.setMonarchTokensProvider('html', highlighterConfig)
monaco.languages.html.htmlDefaults.setOptions(languageOptions)
const placeholderProvider = registerPlaceholderProvider(monaco)
const filterProvider = registerFilterProvider(monaco)
const hoverProvider = registerHoverProvider(monaco)
const model = monaco.editor.createModel(editorStore.current_model, 'html')

// Theme Handling
monaco.editor.defineTheme('teTheme-light', {
  base: 'vs',
  inherit: true,
  rules: tokenColorsLight,
  colors: themeColorsLight,
})

// Events
const errorRange = useEventBus(errorRangeKey)

onMounted(() => {
  // Editor Init
  const editorContainer = document.getElementById('editor') as HTMLElement
  editor = monaco.editor.create(editorContainer, {
    model,
    language: 'html',
    theme: 'vs',
    scrollBeyondLastLine: false,
    minimap: {
      enabled: false,
    },
    wordWrap: 'wordWrapColumn',
    wordWrapColumn: 110,
    wrappingIndent: 'same',
    dragAndDrop: false,
    find: {
      addExtraSpaceOnTop: false,
    },
    renderValidationDecorations: 'on',
  })
  monaco.editor.setTheme('teTheme-light')

  // Validator handling
  validator = new ValidatorWorker()
  const validateCode = (html: string) => {
    const model = editor.getModel()
    if (model) {
      monaco.editor.setModelMarkers(model, 'teslahtml-validator', [])
      validator.postMessage({
        html,
        version: model.getVersionId(),
      })
    }
  }
  const updateMarkers = ({ markers, version }: any) => {
    const model = editor.getModel()
    if (model && model.getVersionId() === version) {
      monaco.editor.setModelMarkers(model, 'teslahtml-validator', markers)
      errorStore.markers = markers
    }
  }

  validator.addEventListener('message', ({ data }: any) => {
    updateMarkers(data)
  })

  const debouncedOnModelChange = (editor: monaco.editor.IStandaloneCodeEditor, callback: Function) => {
    let timeout: NodeJS.Timeout
    const runner = () => {
      callback()
    }
    return editor.getModel()?.onDidChangeContent(() => {
      if (timeout)
        clearTimeout(timeout)

      timeout = setTimeout(runner, 3000)
    })
  }
  validatorListener = debouncedOnModelChange(editor, () => {
    const value = editor.getModel()?.getValue()
    if (value)
      validateCode(value)
  })

  // Resize Observer
  useResizeObserver(editorContainer, (entries) => {
    const entry = entries[0]
    const { width, height } = entry.contentRect
    editor.layout({ width, height })
  })

  // Emit line/col position to the store
  editor.onDidChangeCursorPosition((e) => {
    editorStore.current_position = e.position
  })

  // Listeners
  // Listen for error range click
  const errorRangeListener = (event: monaco.IRange) => {
    const errorPosition: monaco.IPosition = {
      column: event.startColumn,
      lineNumber: event.startLineNumber,
    }
    editor.revealRangeInCenter(event)
    editor.setPosition(errorPosition)
  }
  errorRange.on(errorRangeListener)
})

onBeforeUnmount(() => {
  validator.terminate()
  validatorListener?.dispose()
  placeholderProvider?.dispose()
  filterProvider?.dispose()
  hoverProvider?.dispose()
  editor?.dispose()
})
</script>

<template>
  <pre id="editor" class="main-height main-width" data-lang="text/html" />
</template>
